package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;
import java.util.Arrays;

public class ArrayUtility<T> {

    private T[] inputArray;

    public ArrayUtility(T[] inputArray) {
        this.inputArray = inputArray;
    }

    public Integer countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate) {
        Integer count = 0;
        count += getNumberOfOccurrences(valueToEvaluate);
        for (T t : arrayToMerge){
            if (t.equals(valueToEvaluate)){
                count++;
            }
        }
        return count;
    }

    public Integer getNumberOfOccurrences(T valueToEvaluate) {
        Integer count = 0;
        for (T t : inputArray){
            if (t.equals(valueToEvaluate)){
                count++;
            }
        }
        return count;
    }

    public T[] removeValue(T valueToRemove) {
        Integer count = getNumberOfOccurrences(valueToRemove);
        T[] arr = (T[]) Array.newInstance(inputArray.getClass().getComponentType(), inputArray.length-count);
        for (int i=0, j=0; i<inputArray.length-1; i++){
            if (!(inputArray[i].equals(valueToRemove))){
                arr[j] = inputArray[i];
                j++;
            }
        }
        return arr;
    }

    public T getMostCommonFromMerge(T[] arrayToMerge) {
        T[] mergedArr = mergeArray(arrayToMerge);
        T mostCommonT = mergedArr[0];
        int count = 1;
        for (T t : mergedArr){
            if (getNumberOfOccurrences(t) > count){
                count = getNumberOfOccurrences(t);
                mostCommonT = t;
            }
        }
        return mostCommonT;
    }

    public T[] mergeArray(T[] arrayToMerge){
        T[] mergedArr = Arrays.copyOf(inputArray, inputArray.length + arrayToMerge.length);
        for (int i=0; i<arrayToMerge.length-1; i++){
            mergedArr[i+inputArray.length] = arrayToMerge[i];
        }
        return mergedArr;
    }

}
